//: /be/optiloading/AboutBox.java
/*
 * This work is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This work is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2007 Tim Pintens. All rights reserved.
 */

package be.optiloading;

import javax.swing.*;
import javax.swing.text.*;
import javax.swing.border.*;
import java.awt.*;

/** 
 * AboutBox class which creates an about box containg author information.
 * @author Tim Pintens, info@optiloading.be
 * @author <a target="_blank" href="http://www.optiloading.be">www.optiloading.be</a>
 */

public class AboutBox extends JFrame {
	
	public AboutBox(){
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));
		
		// Image
		java.net.URL imageURL = this.getClass().getResource("/images/about.png");
		ImageIcon about = new ImageIcon(imageURL);
		JLabel image = new JLabel(about);
		image.setAlignmentX(Component.CENTER_ALIGNMENT);
		
		// Title
		JLabel title = new JLabel("OptiLoading");
		title.setFont(new Font("Dialog",Font.BOLD,16));
		title.setAlignmentX(Component.CENTER_ALIGNMENT);
		
		//Version
		JLabel version = new JLabel("beta version 0.2.1");
		version.setFont(new Font("Dialog",Font.PLAIN,10));
		version.setAlignmentX(Component.CENTER_ALIGNMENT);
		
		//License
		JEditorPane license = new JEditorPane();
		license.setEditable(false);
		JScrollPane scroll = new JScrollPane(license);
		scroll.setPreferredSize(new Dimension(230,130));
		scroll.setAlignmentX(Component.CENTER_ALIGNMENT);
		try{
			license.setPage(AboutBox.class.getResource("/help/about.html"));
		}catch (Exception ex){}
		
		//Author
		JLabel author = new JLabel("Tim Pintens <info@optiloading.be>");
		author.setFont(new Font("Dialog",Font.PLAIN,12));
		author.setAlignmentX(Component.CENTER_ALIGNMENT);
		
		// Add to main panel
		panel.add(image);
		panel.add(Box.createVerticalStrut(5));
		panel.add(title);
		panel.add(version);
		panel.add(Box.createVerticalStrut(7));
		panel.add(scroll);
		panel.add(Box.createVerticalStrut(5));
		panel.add(author);
		panel.add(Box.createVerticalStrut(5));
		
		//Configure frame
		setTitle("About");
		setIconImage(new ImageIcon(this.getClass().getResource("/images/icon.png")).getImage());
		getContentPane().add(BorderLayout.CENTER, panel);
		setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		setResizable(false);
		pack();
		setLocationRelativeTo(null);
		setVisible(true);
	}
}