//: /be/optiloading/TestCase.java
/*
 * This work is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This work is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * Copyright (c) 2007 Tim Pintens. All rights reserved.
 */

package be.optiloading;

import java.io.*;

/** 
 * TestCase class is used to test the genetic output without creating a GUI.
 * @author Tim Pintens, info@optiloading.be
 * @author <a target="_blank" href="http://www.optiloading.be">www.optiloading.be</a>
 */

class TestCase{
	private static Ship usedShip;
	private static Population pop;
	private static Population newpop;
	
	public static void main(String[] args) {
		initialize();
		
		pop = new Population();
		newpop = new Population();
		pop.createInitialPopulation();
		Chromosome selected1 = null;
		Chromosome selected2 = null;
		
		for (int j = 0; j < Genetics.GENERATIONS ; j++){

			Chromosome best = pop.getBestchromosome();
			System.out.println("Generation = "+j);
			System.out.println("Mean fitness = "+pop.getTotalfitness()/Genetics.POPSIZE);
			System.out.println("Best volumes = "+best.getVolumes());
			System.out.println("Best fitness = "+best.getFitness());
			System.out.println("Best trim = "+best.getTrim());
			System.out.println("---------------------------------------------------------------------------------------");
			
			for(int i = 0; i < Genetics.POPSIZE; i+=2){
				
				do{
					switch(Genetics.SELECTION){
						case 0: 
						selected1 = pop.selectRankChromosome();
						selected2 = pop.selectRankChromosome();
						break;
						case 1: 
						selected1 = pop.selectRouletteChromosome();
						selected2 = pop.selectRouletteChromosome();
						break;
					}
				} while (selected1.getFitness() == selected2.getFitness());
				
				switch(Genetics.CROSSOVER){
					case 0: selected1.crossOverMean(selected2); break;
					case 1: selected1.crossOverOnePoint(selected2); break;
					case 2: selected1.crossOverTwoPoint(selected2); break;
					case 3: selected1.crossOverUniform(selected2); break;
				}
				
				switch(Genetics.MUTATION){
					case 0: 
					selected1.mutateSwitch();
					selected2.mutateSwitch(); 
					break;
					case 1: 
					selected1.mutateRandom();
					selected2.mutateRandom();
					break;
				}

				newpop.addChromosome(selected1);
				newpop.addChromosome(selected2);

			}
			pop = newpop;
			newpop = new Population();
		}	
	}
	
	private static void initialize(){
		usedShip = Ship.getInstance();
		Cargo load = new Cargo(60000,1);
		usedShip.checkToLoad(load, 1.025f);
		usedShip = null;
	}
}